Index: harmonizer/src/holharm.c
===================================================================
RCS file: /cvsroot/holap/holap/harmonizer/src/holharm.c,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 holharm.c
--- harmonizer/src/holharm.c	26 Dec 2008 12:50:23 -0000	1.1.1.1
+++ harmonizer/src/holharm.c	28 Dec 2008 17:16:29 -0000
@@ -506,12 +506,12 @@
   return -1;
 }
 
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+holharm_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -658,12 +658,12 @@
       holharmDDescriptor->run_multiple_synths_adding = NULL;
     }
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+holharm_fini ()
 {
   if (holharmLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) holharmLDescriptor->PortDescriptors);
       free ((char **) holharmLDescriptor->PortNames);
Index: musicaldelay/src/Makefile.am
===================================================================
RCS file: /cvsroot/holap/holap/musicaldelay/src/Makefile.am,v
retrieving revision 1.1
diff -u -5 -r1.1 Makefile.am
--- musicaldelay/src/Makefile.am	26 Dec 2008 15:38:25 -0000	1.1
+++ musicaldelay/src/Makefile.am	28 Dec 2008 17:16:29 -0000
@@ -7,11 +7,11 @@
 	mdelay.h
 	
 
 AM_LDFLAGS = -module -avoid-version -Wc,-nostartfiles
 
-musicaldelay_la_LDFLAGS = -avoid-version -module -lexpat -shared -export-symbols-regex "ladspa_descriptor"
+musicaldelay_la_LDFLAGS = -avoid-version -module -shared -export-symbols-regex "ladspa_descriptor"
 
 ACLOCAL_AMFLAGS = -I m4
 
 install-data-hook:
 
Index: musicaldelay/src/musicaldelay.c
===================================================================
RCS file: /cvsroot/holap/holap/musicaldelay/src/musicaldelay.c,v
retrieving revision 1.2
diff -u -5 -r1.2 musicaldelay.c
--- musicaldelay/src/musicaldelay.c	26 Dec 2008 19:08:47 -0000	1.2
+++ musicaldelay/src/musicaldelay.c	28 Dec 2008 17:16:29 -0000
@@ -216,12 +216,12 @@
 
 
 }
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+musicaldelay_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -430,12 +430,12 @@
 
 
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+musicaldelay_fini ()
 {
   if (MusicalDelayLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) MusicalDelayLDescriptor->PortDescriptors);
       free ((char **) MusicalDelayLDescriptor->PortNames);
Index: zynalienwah/src/Makefile.am
===================================================================
RCS file: /cvsroot/holap/holap/zynalienwah/src/Makefile.am,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 Makefile.am
--- zynalienwah/src/Makefile.am	26 Dec 2008 12:50:37 -0000	1.1.1.1
+++ zynalienwah/src/Makefile.am	28 Dec 2008 17:16:29 -0000
@@ -7,11 +7,11 @@
 	effectlfo.c \
 	alienwah.h
 
 AM_LDFLAGS = -module -avoid-version -Wc,-nostartfiles
 
-zynalienwah_la_LDFLAGS = -avoid-version -module -lexpat -shared -export-symbols-regex "ladspa_descriptor"
+zynalienwah_la_LDFLAGS = -avoid-version -module -shared -export-symbols-regex "ladspa_descriptor"
 
 ACLOCAL_AMFLAGS = -I m4
 
 install-data-hook:
 
Index: zynalienwah/src/zynalienwah.c
===================================================================
RCS file: /cvsroot/holap/holap/zynalienwah/src/zynalienwah.c,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 zynalienwah.c
--- zynalienwah/src/zynalienwah.c	26 Dec 2008 12:50:38 -0000	1.1.1.1
+++ zynalienwah/src/zynalienwah.c	28 Dec 2008 17:16:29 -0000
@@ -209,12 +209,12 @@
   
 
 }
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+zynalienwah_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -402,12 +402,12 @@
 
 
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+zynalienwah_fini ()
 {
   if (ZynAlienwahLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) ZynAlienwahLDescriptor->PortDescriptors);
       free ((char **) ZynAlienwahLDescriptor->PortNames);
Index: zynchorus/src/Makefile.am
===================================================================
RCS file: /cvsroot/holap/holap/zynchorus/src/Makefile.am,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 Makefile.am
--- zynchorus/src/Makefile.am	26 Dec 2008 12:50:46 -0000	1.1.1.1
+++ zynchorus/src/Makefile.am	28 Dec 2008 17:16:29 -0000
@@ -7,11 +7,11 @@
 	effectlfo.c \
 	chorus.h
 
 AM_LDFLAGS = -module -avoid-version -Wc,-nostartfiles
 
-zynchorus_la_LDFLAGS = -avoid-version -module -lexpat -shared -export-symbols-regex "ladspa_descriptor"
+zynchorus_la_LDFLAGS = -avoid-version -module -shared -export-symbols-regex "ladspa_descriptor"
 
 ACLOCAL_AMFLAGS = -I m4
 
 install-data-hook:
 
Index: zynchorus/src/zynchorus.c
===================================================================
RCS file: /cvsroot/holap/holap/zynchorus/src/zynchorus.c,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 zynchorus.c
--- zynchorus/src/zynchorus.c	26 Dec 2008 12:50:46 -0000	1.1.1.1
+++ zynchorus/src/zynchorus.c	28 Dec 2008 17:16:29 -0000
@@ -209,12 +209,12 @@
 
 
 }
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+zynchorus_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -401,12 +401,12 @@
 
 
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+zynchorus_fini ()
 {
   if (ZynChorusLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) ZynChorusLDescriptor->PortDescriptors);
       free ((char **) ZynChorusLDescriptor->PortNames);
Index: zyneq10band/src/Makefile.am
===================================================================
RCS file: /cvsroot/holap/holap/zyneq10band/src/Makefile.am,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 Makefile.am
--- zyneq10band/src/Makefile.am	26 Dec 2008 12:51:10 -0000	1.1.1.1
+++ zyneq10band/src/Makefile.am	28 Dec 2008 17:16:29 -0000
@@ -8,11 +8,11 @@
 	analogfilter.c \
 	eq10.h
 
 AM_LDFLAGS = -module -avoid-version -Wc,-nostartfiles
 
-zyneq10band_la_LDFLAGS = -avoid-version -module -lexpat -shared -export-symbols-regex "ladspa_descriptor"
+zyneq10band_la_LDFLAGS = -avoid-version -module -shared -export-symbols-regex "ladspa_descriptor"
 
 ACLOCAL_AMFLAGS = -I m4
 
 install-data-hook:
 
Index: zyneq10band/src/zyneq10band.c
===================================================================
RCS file: /cvsroot/holap/holap/zyneq10band/src/zyneq10band.c,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 zyneq10band.c
--- zyneq10band/src/zyneq10band.c	26 Dec 2008 12:51:10 -0000	1.1.1.1
+++ zyneq10band/src/zyneq10band.c	28 Dec 2008 17:16:29 -0000
@@ -191,12 +191,12 @@
   out(eq10, pinputl,pinputr,sample_count);
 
 }
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+zyneq10ban_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -386,12 +386,12 @@
 
 
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+zyneq10ban_fini ()
 {
   if (ZynEq10banLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) ZynEq10banLDescriptor->PortDescriptors);
       free ((char **) ZynEq10banLDescriptor->PortNames);
Index: zyneq3par/src/Makefile.am
===================================================================
RCS file: /cvsroot/holap/holap/zyneq3par/src/Makefile.am,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 Makefile.am
--- zyneq3par/src/Makefile.am	26 Dec 2008 12:51:18 -0000	1.1.1.1
+++ zyneq3par/src/Makefile.am	28 Dec 2008 17:16:29 -0000
@@ -8,11 +8,11 @@
 	analogfilter.c \
 	eq.h
 
 AM_LDFLAGS = -module -avoid-version -Wc,-nostartfiles
 
-zyneq3par_la_LDFLAGS = -avoid-version -module -lexpat -shared -export-symbols-regex "ladspa_descriptor"
+zyneq3par_la_LDFLAGS = -avoid-version -module -shared -export-symbols-regex "ladspa_descriptor"
 
 ACLOCAL_AMFLAGS = -I m4
 
 install-data-hook:
 
Index: zyneq3par/src/zyneq3par.c
===================================================================
RCS file: /cvsroot/holap/holap/zyneq3par/src/zyneq3par.c,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 zyneq3par.c
--- zyneq3par/src/zyneq3par.c	26 Dec 2008 12:51:19 -0000	1.1.1.1
+++ zyneq3par/src/zyneq3par.c	28 Dec 2008 17:16:29 -0000
@@ -183,12 +183,12 @@
   out(eq3, pinputl,pinputr,sample_count);
 
 }
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+zyneq3par_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -356,12 +356,12 @@
 
 
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+zyneq3par_fini ()
 {
   if (ZynEq3parLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) ZynEq3parLDescriptor->PortDescriptors);
       free ((char **) ZynEq3parLDescriptor->PortNames);
Index: zynphaser/src/Makefile.am
===================================================================
RCS file: /cvsroot/holap/holap/zynphaser/src/Makefile.am,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 Makefile.am
--- zynphaser/src/Makefile.am	26 Dec 2008 12:50:53 -0000	1.1.1.1
+++ zynphaser/src/Makefile.am	28 Dec 2008 17:16:29 -0000
@@ -7,11 +7,11 @@
 	effectlfo.c \
 	phaser.h
 
 AM_LDFLAGS = -module -avoid-version -Wc,-nostartfiles
 
-zynphaser_la_LDFLAGS = -avoid-version -module -lexpat -shared -export-symbols-regex "ladspa_descriptor"
+zynphaser_la_LDFLAGS = -avoid-version -module -shared -export-symbols-regex "ladspa_descriptor"
 
 ACLOCAL_AMFLAGS = -I m4
 
 install-data-hook:
 
Index: zynphaser/src/zynphaser.c
===================================================================
RCS file: /cvsroot/holap/holap/zynphaser/src/zynphaser.c,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 zynphaser.c
--- zynphaser/src/zynphaser.c	26 Dec 2008 12:50:54 -0000	1.1.1.1
+++ zynphaser/src/zynphaser.c	28 Dec 2008 17:16:29 -0000
@@ -221,12 +221,12 @@
 
 
 }
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+zynphaser_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -424,12 +424,12 @@
 
 
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+zynphaser_fini ()
 {
   if (ZynPhaserLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) ZynPhaserLDescriptor->PortDescriptors);
       free ((char **) ZynPhaserLDescriptor->PortNames);
Index: zynreverb/src/Makefile.am
===================================================================
RCS file: /cvsroot/holap/holap/zynreverb/src/Makefile.am,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 Makefile.am
--- zynreverb/src/Makefile.am	26 Dec 2008 12:51:02 -0000	1.1.1.1
+++ zynreverb/src/Makefile.am	28 Dec 2008 17:16:29 -0000
@@ -8,11 +8,11 @@
 	analogfilter.c \
 	reverb.h
 
 AM_LDFLAGS = -module -avoid-version -Wc,-nostartfiles
 
-zynreverb_la_LDFLAGS = -avoid-version -module -lexpat -shared -export-symbols-regex "ladspa_descriptor"
+zynreverb_la_LDFLAGS = -avoid-version -module -shared -export-symbols-regex "ladspa_descriptor"
 
 ACLOCAL_AMFLAGS = -I m4
 
 install-data-hook:
 
Index: zynreverb/src/zynreverb.c
===================================================================
RCS file: /cvsroot/holap/holap/zynreverb/src/zynreverb.c,v
retrieving revision 1.1.1.1
diff -u -5 -r1.1.1.1 zynreverb.c
--- zynreverb/src/zynreverb.c	26 Dec 2008 12:51:02 -0000	1.1.1.1
+++ zynreverb/src/zynreverb.c	28 Dec 2008 17:16:29 -0000
@@ -192,12 +192,12 @@
    out(reverb, pinputl,pinputr,sample_count);
 
 }
 
 
-void
-_init ()
+void __attribute__ ((constructor))
+zynreverb_init ()
 {
 
 
   char **port_names;
   LADSPA_PortDescriptor *port_descriptors;
@@ -363,12 +363,12 @@
 
 
 }
 
 
-void
-_fini ()
+void __attribute__ ((destructor))
+zynreverb_fini ()
 {
   if (ZynReverbLDescriptor)
     {
       free ((LADSPA_PortDescriptor *) ZynReverbLDescriptor->PortDescriptors);
       free ((char **) ZynReverbLDescriptor->PortNames);